Index: uspace/srv/bd/vbd/disk.c
===================================================================
--- uspace/srv/bd/vbd/disk.c	(revision b598460af2662df4c20ccda2b3de00d8057bcacd)
+++ uspace/srv/bd/vbd/disk.c	(revision 55f8c6e7f883eebaa94a912da5ef642615faf634)
@@ -173,10 +173,10 @@
 static int vbds_part_by_pid(vbds_part_id_t partid, vbds_part_t **rpart)
 {
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_part_by_pid(%zu)", partid);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_part_by_pid(%zu)", partid);
 
 	list_foreach(vbds_parts, lparts, vbds_part_t, part) {
-		log_msg(LOG_DEFAULT, LVL_NOTE, "%zu == %zu ?", part->pid, partid);
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "%zu == %zu ?", part->pid, partid);
 		if (part->pid == partid) {
-			log_msg(LOG_DEFAULT, LVL_NOTE, "Found match.");
+			log_msg(LOG_DEFAULT, LVL_DEBUG, "Found match.");
 			*rpart = part;
 			return EOK;
@@ -184,5 +184,5 @@
 	}
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "No match.");
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "No match.");
 	return ENOENT;
 }
@@ -190,10 +190,10 @@
 static int vbds_part_by_svcid(service_id_t svcid, vbds_part_t **rpart)
 {
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_part_by_svcid(%zu)", svcid);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_part_by_svcid(%zu)", svcid);
 
 	list_foreach(vbds_parts, lparts, vbds_part_t, part) {
-		log_msg(LOG_DEFAULT, LVL_NOTE, "%zu == %zu ?", part->svc_id, svcid);
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "%zu == %zu ?", part->svc_id, svcid);
 		if (part->svc_id == svcid) {
-			log_msg(LOG_DEFAULT, LVL_NOTE, "Found match.");
+			log_msg(LOG_DEFAULT, LVL_DEBUG, "Found match.");
 			*rpart = part;
 			return EOK;
@@ -201,5 +201,5 @@
 	}
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "No match.");
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "No match.");
 	return ENOENT;
 }
@@ -214,5 +214,5 @@
 	int rc;
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_part_add(%s, %p)",
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_part_add(%s, %p)",
 	    disk->svc_name, lpart);
 
@@ -245,5 +245,5 @@
 	list_append(&part->lparts, &vbds_parts);
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_part_add -> %p", part);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_part_add -> %p", part);
 
 	if (rpart != NULL)
@@ -260,10 +260,10 @@
 	int rc;
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_part_remove(%p)", part);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_part_remove(%p)", part);
 
 	lpart = part->lpart;
 
 	if (part->open_cnt > 0) {
-		log_msg(LOG_DEFAULT, LVL_NOTE, "part->open_cnt = %d",
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "part->open_cnt = %d",
 		    part->open_cnt);
 		return EBUSY;
@@ -355,5 +355,5 @@
 	int rc;
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_disk_add(%zu)", sid);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_disk_add(%zu)", sid);
 
 	/* Check for duplicates */
@@ -373,5 +373,5 @@
 	}
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "block_init(%zu)", sid);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "block_init(%zu)", sid);
 	rc = block_init(EXCHANGE_SERIALIZE, sid, 2048);
 	if (rc != EOK) {
@@ -394,5 +394,5 @@
 	rc = label_open(sid, &label);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_NOTE, "Failed to open label in disk %s.",
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed to open label in disk %s.",
 		    disk->svc_name);
 		rc = EIO;
@@ -414,5 +414,5 @@
 	label_close(label);
 	if (block_inited) {
-		log_msg(LOG_DEFAULT, LVL_NOTE, "block_fini(%zu)", sid);
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "block_fini(%zu)", sid);
 		block_fini(sid);
 	}
@@ -428,5 +428,5 @@
 	int rc;
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_disk_remove(%zu)", sid);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_disk_remove(%zu)", sid);
 
 	rc = vbds_disk_by_svcid(sid, &disk);
@@ -442,5 +442,5 @@
 	list_remove(&disk->ldisks);
 	label_close(disk->label);
-	log_msg(LOG_DEFAULT, LVL_NOTE, "block_fini(%zu)", sid);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "block_fini(%zu)", sid);
 	block_fini(sid);
 	free(disk);
@@ -483,5 +483,5 @@
 	int rc;
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_disk_info(%zu)", sid);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_disk_info(%zu)", sid);
 
 	rc = vbds_disk_by_svcid(sid, &disk);
@@ -498,5 +498,5 @@
 	info->anblocks = linfo.anblocks;
 	info->block_size = disk->block_size;
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_disk_info - block_size=%zu",
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_disk_info - block_size=%zu",
 	    info->block_size);
 	return EOK;
@@ -540,5 +540,5 @@
 	int rc;
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_label_create(%zu)", sid);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_label_create(%zu)", sid);
 
 	/* Find disk */
@@ -547,5 +547,5 @@
 		return rc;
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_label_create(%zu) - label_close", sid);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_label_create(%zu) - label_close", sid);
 
 	/* Verify that current label is a dummy label */
@@ -569,5 +569,5 @@
 	disk->label = NULL;
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_label_create(%zu) - label_create", sid);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_label_create(%zu) - label_create", sid);
 
 	rc = label_create(sid, ltype, &label);
@@ -578,12 +578,12 @@
 	disk->label = label;
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_label_create(%zu) - success", sid);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_label_create(%zu) - success", sid);
 	return EOK;
 error:
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_label_create(%zu) - failure", sid);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_label_create(%zu) - failure", sid);
 	if (disk->label == NULL) {
 		rc = label_open(sid, &label);
 		if (rc != EOK) {
-			log_msg(LOG_DEFAULT, LVL_NOTE, "Failed to open label in disk %s.",
+			log_msg(LOG_DEFAULT, LVL_ERROR, "Failed to open label in disk %s.",
 			    disk->svc_name);
 		}
@@ -599,5 +599,5 @@
 	int rc;
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_label_delete(%zu)", sid);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_label_delete(%zu)", sid);
 
 	rc = vbds_disk_by_svcid(sid, &disk);
@@ -621,5 +621,5 @@
 	rc = label_open(disk->svc_id, &label);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_NOTE, "Failed to open label in disk %s.",
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed to open label in disk %s.",
 		    disk->svc_name);
 		return EIO;
@@ -660,14 +660,14 @@
 	int rc;
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_part_create(%zu)", sid);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_part_create(%zu)", sid);
 
 	rc = vbds_disk_by_svcid(sid, &disk);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_NOTE, "Disk %zu not found",
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Disk %zu not found",
 		    sid);
 		goto error;
 	}
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_part_crate(%zu): "
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_part_crate(%zu): "
 	    "index=%d block0=%" PRIu64 " nblocks=%" PRIu64
 	    " hdr_blocks=%" PRIu64 " pkind=%d",
@@ -760,5 +760,5 @@
 	rc = vbds_disk_by_svcid(sid, &disk);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_NOTE, "Disk %zu not found",
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "Disk %zu not found",
 		    sid);
 		goto error;
@@ -767,5 +767,5 @@
 	rc = label_suggest_ptype(disk->label, pcnt, ptype);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_NOTE, "label_suggest_ptype() failed");
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "label_suggest_ptype() failed");
 		goto error;
 	}
@@ -780,5 +780,5 @@
 	vbds_part_t *part = bd_srv_part(bd);
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_bd_open()");
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_bd_open()");
 	part->open_cnt++;
 	return EOK;
@@ -789,5 +789,5 @@
 	vbds_part_t *part = bd_srv_part(bd);
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_bd_close()");
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_bd_close()");
 	part->open_cnt--;
 	return EOK;
@@ -800,5 +800,5 @@
 	aoff64_t gba;
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_bd_read_blocks()");
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "vbds_bd_read_blocks()");
 
 	if (cnt * part->disk->block_size < size)
@@ -816,5 +816,5 @@
 	aoff64_t gba;
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_bd_sync_cache()");
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "vbds_bd_sync_cache()");
 
 	/* XXX Allow full-disk sync? */
@@ -835,5 +835,5 @@
 	aoff64_t gba;
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_bd_write_blocks()");
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "vbds_bd_write_blocks()");
 
 	if (cnt * part->disk->block_size < size)
@@ -850,5 +850,5 @@
 	vbds_part_t *part = bd_srv_part(bd);
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_bd_get_block_size()");
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "vbds_bd_get_block_size()");
 	*rsize = part->disk->block_size;
 	return EOK;
@@ -859,5 +859,5 @@
 	vbds_part_t *part = bd_srv_part(bd);
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_bd_get_num_blocks()");
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "vbds_bd_get_num_blocks()");
 	*rnb = part->nblocks;
 	return EOK;
@@ -870,13 +870,13 @@
 	service_id_t svcid;
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_bd_conn()");
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_bd_conn()");
 
 	svcid = IPC_GET_ARG1(*icall);
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_bd_conn() - svcid=%zu", svcid);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_bd_conn() - svcid=%zu", svcid);
 
 	rc = vbds_part_by_svcid(svcid, &part);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_NOTE, "vbd_bd_conn() - partition "
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "vbd_bd_conn() - partition "
 		    "not found.");
 		async_answer_0(iid, EINVAL);
@@ -884,5 +884,5 @@
 	}
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_bd_conn() - call bd_conn");
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_bd_conn() - call bd_conn");
 	bd_conn(iid, icall, &part->bds);
 }
@@ -915,5 +915,5 @@
 	}
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "loc_service_register('%s')",
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "loc_service_register('%s')",
 	    name);
 	rc = loc_service_register(name, &psid);
@@ -952,5 +952,5 @@
 	int rc;
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_part_svc_unregister("
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_part_svc_unregister("
 	    "disk->svc_name='%s', id=%zu)", part->disk->svc_name, part->svc_id);
 
@@ -970,5 +970,5 @@
 	int rc;
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "vbds_part_indices_update()");
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_part_indices_update()");
 
 	/* First unregister services for partitions whose index has changed */
@@ -977,5 +977,5 @@
 			rc = vbds_part_svc_unregister(part);
 			if (rc != EOK) {
-				log_msg(LOG_DEFAULT, LVL_NOTE, "Error "
+				log_msg(LOG_DEFAULT, LVL_ERROR, "Error "
 				    "un-registering partition.");
 				return EIO;
@@ -990,5 +990,5 @@
 			rc = vbds_part_svc_register(part);
 			if (rc != EOK) {
-				log_msg(LOG_DEFAULT, LVL_NOTE, "Error "
+				log_msg(LOG_DEFAULT, LVL_ERROR, "Error "
 				    "re-registering partition.");
 				return EIO;